export default class InputEleRef{
    element:any;
    private eventObject:{change?:boolean,blur?:boolean,focus?:boolean,submit?:boolean,keyUp?:boolean}={change:false,blur:false,focus:false,submit:false,keyUp:false};
    parse:Function;
    validation:Function;
    onChange:Function;
    onBlur:Function;
    onFocus:Function;
    onKeyUp:Function;
    defaultValue:any;
    bindRef(ele:any){ 
        if(this.element != ele){
            this.element=ele;
            this.element.value=this.defaultValue || null
            if(this.eventObject.change){
                this.element.addEventListener("change",(e)=>{
                    let vstr=this.processExecution();
                    if(this.onChange){
                        this.onChange(vstr,e);
                    }
                })
            }

            if(this.eventObject.keyUp){
                this.element.addEventListener("keyup",(e)=>{
                    let vstr=this.processExecution();
                    if(this.onKeyUp){
                        this.onKeyUp(vstr,e);
                    }
                })  
            }

            if(this.eventObject.blur){
                this.element.addEventListener("blur",(e)=>{
                    let vstr=this.processExecution();
                    if(this.onBlur){
                        this.onBlur(vstr,e);
                    }
                })
            }
            if(this.eventObject.focus){
                this.element.addEventListener("blur",(e)=>{
                    let vstr=this.processExecution();
                    if(this.onFocus){
                        this.onFocus(vstr,e);
                    }
                })
            }
        }
    }
    processExecution(){
        let vstr=null;
        if(this.parse){
            this.element.value=this.parse(this.element.value);
        }
        if(this.validation){
            vstr=this.validation(this.element.value)
        }
        return vstr;
    }
    getValue(){
        return this.element.value
    }
    setValue(value:any){
        this.element.value=value;
    }

}